<%@ Page Language="C#" Debug="true" %>

<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Security" %>
<%@ Import Namespace="System.Security.Cryptography" %>
<%@ Import Namespace="System.Security.Cryptography.X509Certificates" %>

<script runat="server">
	private bool DummyCertificateValidator(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
	{
		return true;
	}
	
    protected void Page_Load(object sender, EventArgs e)
    {
        // Load settings
        bool ssl = false;
        if (ConfigurationSettings.AppSettings["PINsafe_SSL"] != null)
            ssl = ConfigurationSettings.AppSettings["PINsafe_SSL"].ToLower().Equals("true");

        string server = "localhost";
        if (ConfigurationSettings.AppSettings["PINsafe_Server"] != null)
            server = ConfigurationSettings.AppSettings["PINsafe_Server"];

        int port = 8080;
        if (ConfigurationSettings.AppSettings["PINsafe_Port"] != null)
            try {
                port = Int32.Parse(ConfigurationSettings.AppSettings["PINsafe_Port"]);
            } catch (FormatException fe) { }

        string context = "pinsafe";
        if (ConfigurationSettings.AppSettings["PINsafe_Context"] != null)
            context = ConfigurationSettings.AppSettings["PINsafe_Context"];
                
        // Construct URL for image
        StringBuilder url;
        if (ssl)
            url = new StringBuilder("https://");
        else
            url = new StringBuilder("http://");

        url.AppendFormat("{0}:{1}/{2}/SCImage?username={3}", server, port, context, Request.QueryString["username"]);
        
        // Request image
		bool acceptSelfSigned = false;
		if (ConfigurationSettings.AppSettings["PINsafe_AcceptSelfSigned"] != null) {
			acceptSelfSigned = ConfigurationSettings.AppSettings["PINsafe_AcceptSelfSigned"].ToLower().Equals("true");
		}
		if (acceptSelfSigned) {
			ServicePointManager.ServerCertificateValidationCallback = DummyCertificateValidator;
		}
        WebRequest imgRequest = HttpWebRequest.Create(url.ToString());
        WebResponse imgResponse = imgRequest.GetResponse();
        Stream imgStream = imgResponse.GetResponseStream();
        
        // Read image data from stream and write it to client
        byte[] imgBuffer = new byte[1024];
        int read = 0;
        int imgSize = 0;
        do
        {
            imgSize += read;
            read = imgStream.Read(imgBuffer, 0, imgBuffer.Length);
            Response.OutputStream.Write(imgBuffer, 0, read);
        } while (read > 0);
        
        // Close image stream
        imgStream.Close();

        // Set correct content type
        Response.ContentType = imgResponse.ContentType;
        
        // Set correct content length
        Response.AddHeader("Content-Length", imgSize.ToString());

        // Try and prevent caching
        Response.CacheControl = "private";
        Response.ExpiresAbsolute = new DateTime(1970, 1, 1);
        Response.AddHeader("Pragma", "no-cache");

        // Done
        Response.End();
    }
</script>
